<template>
  <el-form ref="form" :model="userPassword" :rules="rules" label-width="80px">
    <el-form-item label="旧密码" prop="oldPassword">
      <el-input
        v-model="userPassword.oldPassword"
        placeholder="请输入旧密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item label="新密码" prop="password">
      <el-input
        v-model="userPassword.password"
        placeholder="请输入新密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item label="确认密码" prop="confirmPassword">
      <el-input
        v-model="userPassword.confirmPassword"
        placeholder="请确认新密码"
        type="password"
        show-password
      />
    </el-form-item>
    <el-form-item>
      <el-button type="primary" size="mini" @click="submit">保存</el-button>
      <el-button type="danger" size="mini" @click="close">关闭</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
import { editUser } from "@/api/personalCenter.js";
import { updatepwd } from "@/api/sysManage";
import store from "@/store";
export default {
  props: {
    user: {
      type: Object,
    },
  },
  data() {
    const equalToPassword = (rule, value, callback) => {
      if (this.userPassword.password !== value) {
        callback(new Error("两次输入的密码不一致"));
      } else {
        callback();
      }
    };
    return {
      userPassword: {
        oldPassword: undefined,
        password: undefined,
        confirmPassword: undefined,
        id: null,
      },
      // 表单校验
      rules: {
        oldPassword: [
          { required: true, message: "旧密码不能为空", trigger: "blur" },
        ],
        password: [
          { required: true, message: "新密码不能为空", trigger: "blur" },
          {
            min: 6,
            max: 20,
            message: "长度在 6 到 20 个字符",
            trigger: "blur",
          },
        ],
        confirmPassword: [
          { required: true, message: "确认密码不能为空", trigger: "blur" },
          { required: true, validator: equalToPassword, trigger: "blur" },
        ],
      },
    };
  },
  methods: {
    submit() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          this.userPassword.id = this.user.id;
          editUser(this.userPassword).then((response) => {
            if (response.code == 200) {
              this.$message({
                message: "修改成功",
                type: "success",
              });
              store.dispatch("user/resetToken").then(() => {
                location.reload();
              });
            } else {
              this.$message.error(response.msg);
            }
          });
        }
      });
    },
    close() {
      this.$router.push("/dashboard");
    },
  },
};
</script>
